#!/usr/bin/python 
import string,cgi,time,webFrameWork,traceback
import os
from BaseHTTPServer import BaseHTTPRequestHandler , HTTPServer
from SocketServer import ThreadingMixIn

basepath = "onelastmidget"

class KenWeb(BaseHTTPRequestHandler,webFrameWork.webFrameWork):
    def server_activate(self):
        self.socket.settimeout(4)
        self.socket.listen(self.request_queue_size)

    def address_string(self):
	return self.client_address[0]

    def do_GET(self):
        if not self.checkKenPath():
            self.send_response(404)
            self.send_header('Content-type','text/html')
            self.end_headers()
            html = self.buildNotFound()
            self.wfile.write(html)
            return 

        if self.path == "/":
            self.send_response(200)
            self.send_header('Content-type','text/html')
            self.end_headers()
            html = self.engine(None)
            self.wfile.write(html)
            return
        elif  "/images" in self.path:
            self.send_response(200)
            self.send_header('Content-type','image/jpeg')
            self.end_headers()
            path = os.path.join(os.curdir,os.sep,self.path)
            f =  open("."+path)
            if f:
                self.wfile.write(f.read())
                return
            else:
                print "file not found"
                return
        else:
            self.send_response(404)
            self.send_header('Content-type','text/html')
            self.end_headers()
            html = self.buildNotFound()
            self.wfile.write(html)
            return
  

    def do_POST(self):
        if not self.checkKenPath():
            self.send_response(404)
            self.send_header('Content-type','text/html')
            self.end_headers()
            html = self.buildNotFound()
            self.wfile.write(html)
            return 

        if self.path == "/":
            try:
                ctype,pdict = cgi.parse_header(self.headers.getheader('content-type'))
                self.send_response(200)
                self.send_header('Content-type','text/html')
                self.end_headers()
                length = int(self.headers.getheader('content-length'))
                qslen = self.rfile.read(length) 
                self.qs = cgi.parse_qs(qslen, keep_blank_values=1) 
                html = self.engine(self.qs)
                self.wfile.write(html)
                return   
            except:
                traceback.print_exc()
        else:
            self.send_response(404)
            self.send_header('Content-type','text/html')
            self.end_headers()
            html = self.buildNotFound()
            self.wfile.write(html)
            return
  
    def checkKenPath(self):
        pathArray = self.path.split("/")
        if(pathArray[1] == basepath):
            self.path = "/"+"/".join(pathArray[2:])
            return True
        else:
            return False
        
class myServer(ThreadingMixIn, HTTPServer):
    pass
            
        
def main():
    try:
        server = myServer(('',8093),KenWeb)
        print 'started httpserver....'
        server.serve_forever()
    except KeyboardInterrupt:
        print "Closing Server..."
        server.socket.close()


if __name__ == '__main__':
    main()

